<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/GenericAGSymbol.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">GenericAGSymbol.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_generic_a_g_symbol_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//GenericAGSymbol.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef _GENERICAGSYMBOL_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define _GENERICAGSYMBOL_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// This class corresponds to symbols in the grammar file which do not require unique</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">// attributes and specialised methods for updating attributes. Examples are</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// blank space character in this case, but also opening and closes braces</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// for some other problems.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_a_g_symbol_8h.html">AGSymbol.h</a>&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="class_generic_a_g_symbol.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_generic_a_g_symbol.html">GenericAGSymbol</a> : <span class="keyword">public</span> <a class="code" href="class_a_g_symbol.html">AGSymbol</a>{</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">public</span>:</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;                <a class="code" href="class_generic_a_g_symbol.html">GenericAGSymbol</a>(<span class="keyword">const</span> <span class="keywordtype">string</span>, <span class="keyword">const</span> <a class="code" href="_symbol_8h.html#add8909e1085c0c32f8380ff493a243b3">SymbolType</a>);</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;                <a class="code" href="class_generic_a_g_symbol.html">GenericAGSymbol</a>(<span class="keyword">const</span> <a class="code" href="class_generic_a_g_symbol.html">GenericAGSymbol</a>&amp;);</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;                ~<a class="code" href="class_generic_a_g_symbol.html">GenericAGSymbol</a>();</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;                <span class="keyword">virtual</span> <a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a> updateSynthesisedAttributes(<a class="code" href="class_a_g_context.html">AGContext</a> &amp;, <span class="keyword">const</span> <span class="keywordtype">int</span> prodIndex, <a class="code" href="class_a_g_look_up.html">AGLookUp</a>&amp; lookUp);</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;                <span class="keyword">virtual</span> <a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a> updateInheritedAttributes(<a class="code" href="class_a_g_context.html">AGContext</a> &amp;, <span class="keyword">const</span> <span class="keywordtype">int</span> prodIndex, <a class="code" href="class_a_g_look_up.html">AGLookUp</a>&amp; lookUp);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;                <a class="code" href="class_generic_a_g_symbol.html">GenericAGSymbol</a> &amp;operator=(<span class="keyword">const</span> <a class="code" href="class_generic_a_g_symbol.html">GenericAGSymbol</a>);</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;};</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#endif</span></div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclass_a_g_symbol_html"><div class="ttname"><a href="class_a_g_symbol.html">AGSymbol</a></div><div class="ttdef"><b>Definition:</b> AGSymbol.h:37</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html"><div class="ttname"><a href="_a_g_symbol_8h.html">AGSymbol.h</a></div></div>
<div class="ttc" id="aclass_generic_a_g_symbol_html"><div class="ttname"><a href="class_generic_a_g_symbol.html">GenericAGSymbol</a></div><div class="ttdef"><b>Definition:</b> GenericAGSymbol.h:16</div></div>
<div class="ttc" id="a_symbol_8h_html_add8909e1085c0c32f8380ff493a243b3"><div class="ttname"><a href="_symbol_8h.html#add8909e1085c0c32f8380ff493a243b3">SymbolType</a></div><div class="ttdeci">SymbolType</div><div class="ttdef"><b>Definition:</b> Symbol.h:24</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html_a957d51e6618189668fefc29a518bf28a"><div class="ttname"><a href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a></div><div class="ttdeci">AGMapState</div><div class="ttdef"><b>Definition:</b> AGSymbol.h:32</div></div>
<div class="ttc" id="aclass_a_g_look_up_html"><div class="ttname"><a href="class_a_g_look_up.html">AGLookUp</a></div><div class="ttdef"><b>Definition:</b> AGLookUp.h:22</div></div>
<div class="ttc" id="aclass_a_g_context_html"><div class="ttname"><a href="class_a_g_context.html">AGContext</a></div><div class="ttdef"><b>Definition:</b> AGContext.h:28</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
